#include <vector>
#include <list>
#include <queue>
#include <algorithm>

#define VAR (v,x)  __typeof(x) v=x
#define FOREACH (i,c) for (VAR (i, (c).begin ()); i != (c).end (); ++i) 
#define REP (i, n) for (int i =0; i < (n); ++i)

using namespace std;

struct edge {
  int target;
  int w;
  int a;
  int t;
  int l;
};

int best [100000];
vector <edge> sasiad [100000];
bool visited [100000]; 

int kopiec [100000];
int indexk [100000];
int tab [100000], tabodw [100000];
int tab_n;

int kopiec_por (int a, int b) {
  return best[tab [kopiec [a]]] - best [tab [kopiec [b]]];
}

void zamien (int a, int b) {
  int temp;
  temp = kopiec [a];
  kopiec [a] = kopiec [b];
  kopiec [b] = temp;
  temp = indexk [kopiec [a]];
  indexk [kopiec [a]] = indexk [kopiec [b]];
  indexk [kopiec [b]] = temp;
}

void kopcujwdol (int ktory) {
  int lewy, prawy, naj;
  naj = ktory;
  do { 
    ktory = naj; 
    lewy = ktory << 1;
    prawy = (ktory << 1) + 1;
    if (lewy <= kopiec [0] && kopiec_por (lewy, ktory) < 0)
      naj = lewy;
    else
      naj = ktory;
    if (prawy <= kopiec [0] && kopiec_por (prawy, naj) < 0)
      naj = prawy;

    zamien (ktory, naj);
  }
  while (ktory != naj);
}

void kopcujwgore (int ktory) {
  while (ktory  > 1 && kopiec_por (ktory >> 1, ktory) > 0) { 
    zamien (ktory, ktory >> 1);
    ktory >>= 1;
  }
}

int wez_min () { 
  int result, ind;

  ind = kopiec [1];
  zamien (1, kopiec [0]);
  kopiec[0] --;
  kopcujwdol (1);
  result = tab[ind];
  tab[ind] = tab[--tab_n];
  tabodw [tab[ind]] = ind;
  kopiec[indexk[tab_n]] = ind;
  indexk[ind] = indexk[tab_n];
  return result;
}

void dodaj (int a) { 
  tab[tab_n] = a;
  tabodw [a] = tab_n;
  kopiec [0]++;
  kopiec[kopiec [0]] = tab_n;
  indexk[tab_n] = kopiec [0];
  tab_n++;
  kopcujwgore(kopiec [0]);
}

void zmien (int i, int na) {
  if (best [i] < na) {
    best [i] = na;
    kopcujwdol (indexk [tabodw [i]]);
  }
  else { 
    best [i] = na;
    kopcujwgore (indexk[tabodw [i]]);
  }
}

int czas (int cur, edge &e) {
  //  printf ("czas (cur %d) %d %d %d\n", cur, e.t, e.a, e.l);
  if (e.t == 0 && e.a == 0 && e.l == 0) {
    return cur + e.w;
  }
  else if (e.l < e.w) return 2000000000;
  else {
    int begin = max (e.a, cur) - e.a;
    int rest = begin % e.t;
    if (rest + e.w <= e.l)
      return begin + e.a + e.w;
    else
      return begin + (e.t - rest) + e.w + e.a;
  }
}

void oblicz () {
  int n, m;
  scanf ("%d %d", &n, &m);
  for (int i = 0; i < n; i++) {
    best [i] = 2000000000;
    visited [i] = false;
    sasiad [i].clear ();
  }

  int i = m;
  while (i > 0) {
    int x;
    edge e;
    scanf ("%d %d %d %d %d %d", &x, &e.target, &e.w, &e.t, &e.a, &e.l);
    x--;
    e.target--;
    sasiad [x].push_back (e);
    --i;
  }

  kopiec[0] = 0;
  tab_n = 0;

  //  priority_queue <S> kol;
  // kol.push (S(0));
  //  visited [0] = true;
  best [0] = 0;
  dodaj (0);

  //  printf ("%d\n", kol.s

  while (kopiec [0] > 0) {
    int x = wez_min ();

    if (!visited [x]) {
      //      printf ("%d %d\n", x, best[x]);
            visited [x] = true;
      for (vector<edge>::iterator e = sasiad[x].begin (); e != sasiad[x].end(); ++e) {
	int step = czas (best[x], *e);
	if (step < best[e -> target]) {
	  if (best [e -> target] != 2000000000)
	    zamien (e -> target, step);
	  else {
	    best [e -> target] = step;
	    dodaj (e -> target);
	  }
	}
      }
    }
  };
  if (best [n - 1] == 2000000000) 
    printf ("NIE\n");
  else
    printf ("%d\n", best [n - 1]);
}

int main () {
  int d;

  scanf ("%d", &d);
  while (d > 0) {
    oblicz ();
    --d;
  }

  return 0;
}
