#include <stdio.h>

const int MAX_S = 40003;
const int MAX_K = 20003;
const int MAX_N = 1003;

int N;
int X[MAX_N+1];
int S;
int SP[MAX_N+1];

char tabP[MAX_N+1][MAX_K+1];

char P(int k, int g);

int main()
{
	int T;

	scanf("%d", &T);
	for ( int t = 0; t < T; ++t )
	{
		SP[0] = 0; S = 0;
		scanf("%d", &N);		
		for ( int n = 1; n <= N; ++n )
		{
			int x;
			scanf("%d", &x);
			S += x;
			SP[n] = SP[n-1] + x;
			X[n] = x;
		}
		
		for ( int k = 0; k <= N+1; ++k )
			for ( int n = 0; n <= S/2+2; ++n )
				tabP[k][n] = -1;

		printf("%s\n", (P(0,0) == 1 ? "TAK" : "NIE"));
	}
}


char P(int k, int g)
{
	if ( tabP[k][g] != -1 )  return tabP[k][g];

	// przegrana
	if ( k == N )  
	{
		tabP[k][g] = 0;
		return 0;
	}

	int add = 0;
	int moves = 0;
	for ( int i = 1; i <= 4; ++i )
	{
		add = SP[k+i] - SP[k];
		int g_opp = SP[k] - g;

		if ( k+i <= N )
		{	
			if ( S%2==0 && g+add == S/2 )
			{
				tabP[k][g] = 1;
				return 1;
			}

			if ( g + add <= S/2 && P(k+i, g_opp) == 0 )
			{
				tabP[k][g] = 1;
				return 1;
			}
		}
	}

	tabP[k][g] = 0;
	return 0;
}
